/*
 * gpio.c
 *
 *  Created on: Apr 1, 2014
 *      Author: a0220410
 */
#include "board_gpio.h"
#include "gpio.h"
#include "HapticErrNo.h"
#include "board_config.h"

static uint8_t g_ENLedOn = 0;

void board_GPIO_config(){
#if 0
    //Enable P1.3 internal resistance as pull-Up resistance
    GPIO_setAsInputPinWithPullUpresistor(
    		INTERRUPT_PORT,
    		INTERRUPT_PIN1
            );

    //P1.3 interrupt enabled
    GPIO_enableInterrupt(
    		INTERRUPT_PORT,
    		INTERRUPT_PIN1
            );

    //P1.3 Hi/Lo edge
    GPIO_interruptEdgeSelect(
    		INTERRUPT_PORT,
    		INTERRUPT_PIN1,
            GPIO_HIGH_TO_LOW_TRANSITION
            );


    //P1.3 IFG cleared
    GPIO_clearInterruptFlag(
    		INTERRUPT_PORT,
    		INTERRUPT_PIN1
            );
#endif

}

void LightLED_EN(uint8_t on)
{
	if((g_ENLedOn == 0)&&(on > 0)){
		GPIO_setAsOutputPin(LED_PORT_EN, LED_PIN_EN);
		GPIO_setOutputHighOnPin(LED_PORT_EN, LED_PIN_EN);
		g_ENLedOn = 1;
	}else if((g_ENLedOn > 0)&&(on == 0)){
		GPIO_setAsOutputPin(LED_PORT_EN, LED_PIN_EN);
		GPIO_setOutputLowOnPin(LED_PORT_EN, LED_PIN_EN);
		g_ENLedOn = 0;
	}
}

int GPIO_Config(uint8_t Config, uint8_t Bank, uint16_t PinNum, uint16_t *pErrNum)
{
	int ret = 0;
	uint8_t mode = (Config&0xc0)>>6;
	switch(mode)
	{
		case 0:		//GPIO Input
		{
			uint8_t state = (Config&0x30)>>4;
			switch(state)
			{
				case 0:GPIO_setAsInputPin(Bank,PinNum);break;
				case 1:GPIO_setAsInputPinWithPullUpresistor(Bank,PinNum);break;
				case 2:GPIO_setAsInputPinWithPullDownresistor(Bank,PinNum);break;
				default:
					ret = -1;
					*pErrNum = INVALID_PARAMETER;
					break;;
			}
		}
		break;

		case 1:
		{
			uint8_t state = (Config&0x08)>>3;
			GPIO_setAsOutputPin(Bank, PinNum);
			if(state == 1)
				GPIO_setOutputHighOnPin(Bank,PinNum);
			else
				GPIO_setOutputLowOnPin(Bank,PinNum);
		}
		break;

		case 2:
		{
			uint8_t IEdge = (Config&0x04)>>2;
			uint8_t IEnable = (Config&0x02)>>1;
			if(IEdge == 1){
				GPIO_setAsInputPinWithPullUpresistor(Bank,PinNum);
				GPIO_interruptEdgeSelect(Bank,PinNum,GPIO_HIGH_TO_LOW_TRANSITION);
			}else{
				GPIO_setAsInputPinWithPullDownresistor(Bank,PinNum);
				GPIO_interruptEdgeSelect(Bank,PinNum,GPIO_LOW_TO_HIGH_TRANSITION);
			}

			if(IEnable == 1)
				GPIO_disableInterrupt(Bank,PinNum);
			else
				GPIO_enableInterrupt(Bank,PinNum);
		}
		break;

		case 3:
		{
			uint8_t pfMode = Config&0x01;
			if(pfMode == 1)
				GPIO_setAsPeripheralModuleFunctionInputPin(Bank,PinNum);
			else
				GPIO_setAsPeripheralModuleFunctionOutputPin(Bank,PinNum);
		}
		break;

		default:
			ret = -1;
			*pErrNum = INVALID_PARAMETER;
			break;
	}

	return ret;
}
//******************************************************************************
//
//This is the PORT1_VECTOR interrupt vector service routine
//
//******************************************************************************
#if defined(__TI_COMPILER_VERSION__) || defined(__IAR_SYSTEMS_ICC__)
#pragma vector=PORT1_VECTOR
__interrupt
#elif defined(__GNUC__)
__attribute__((interrupt(PORT1_VECTOR)))
#endif
void Port_1(void)
{
#if 0
	GPIO_toggleOutputOnPin(LED_PORT_EN, LED_PIN_EN);

	if (GPIO_INPUT_PIN_LOW == GPIO_getInputPinValue(
			INTERRUPT_PORT,
			INTERRUPT_PIN1)) {
		GPIO_toggleOutputOnPin(LED_PORT_M, LED_PIN_M0);
	}else{
		GPIO_toggleOutputOnPin(LED_PORT_M, LED_PIN_M1);
	}
#endif
    //P1.3 IFG cleared
    GPIO_clearInterruptFlag(
    		INTERRUPT_PORT,
    		INTERRUPT_PIN1
            );
}
